/***************************************************************************
 *   Private definitions for the VM library.                               *
 *                                                                         *
 *   Copyright (C) 2001-2004 Marko Grnroos <magi@iki.fi>                  *
 *                                                                         *
 ***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef __MAGIC_VMPRIV_H_
#define __MAGIC_VMPRIV_H_

/*******************************************************************************
 * Bytecode definitions
 ******************************************************************************/
enum vm_bytecodes {
	VMBC_BRK  = 0x00,
	VMBC_NOP  = 0x01,
	VMBC_FORK = 0x02,
	VMBC_JOIN = 0x03,
	
	// Memory movement:
	VMBC_PUSH = 0x04,
	VMBC_DROP = 0x05,
	VMBC_DUP  = 0x06,
	VMBC_SWAP = 0x07,
	VMBC_ROT  = 0x08,
	
	// Branching:
	VMBC_IFZ  = 0x09,
	VMBC_NTVC = 0x0a,
	
	// Misc
	VMBC_DATA = 0x0b,
	VMBC_VAL  = 0x0c,
	VMBC_STO  = 0x0d,
};

typedef struct bytecodename_s {
	int         bytecode;
	const char* name;
} bytecodename;

extern bytecodename bytecodes_names[];

#endif
